//
//  ViewController.swift
//  ColorPicker
//
//  Created by Holger Hinzberg on 04.01.16.
//  Copyright © 2016 Holger Hinzberg. All rights reserved.
//

import UIKit

class ViewController: UIViewController,
    UIPickerViewDataSource, UIPickerViewDelegate
{
    // Ein Array als private Eigenschaft
    private var colorsInformation:[ColorInformation]?
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        
        // Ein schwarzer oder ein transparenter
        // Hintergrund sollen nicht möglich sein
        self.colorsInformation = [ColorInformation]()
        
        self.colorsInformation?.append(
          ColorInformation(color: UIColor.whiteColor(),
          name: "Weiß"))
        
        self.colorsInformation?.append(
            ColorInformation(color: UIColor.darkGrayColor(),
                name: "Dunkelgrau"))
        
        self.colorsInformation?.append(
            ColorInformation(color: UIColor.lightGrayColor(),
                name: "Hellgrau"))
        
        self.colorsInformation?.append(
            ColorInformation(color: UIColor.grayColor(),
                name: "Grau"))
        
        self.colorsInformation?.append(
            ColorInformation(color: UIColor.redColor(),
                name: "Rot"))
        
        self.colorsInformation?.append(
            ColorInformation(color: UIColor.greenColor(),
                name: "Grün"))
        
        self.colorsInformation?.append(
            ColorInformation(color: UIColor.blueColor(),
                name: "Blau"))
        
        self.colorsInformation?.append(
            ColorInformation(color: UIColor.cyanColor(),
                name: "Cyan"))
        
        self.colorsInformation?.append(
            ColorInformation(color: UIColor.yellowColor(),
                name: "Gelb"))
        
        self.colorsInformation?.append(
            ColorInformation(color: UIColor.magentaColor(),
                name: "Magenta"))
        
        self.colorsInformation?.append(
            ColorInformation(color: UIColor.orangeColor(),
                name: "Orange"))
        
        self.colorsInformation?.append(
            ColorInformation(color: UIColor.purpleColor(),
                name: "Violett"))
        
        self.colorsInformation?.append(
            ColorInformation(color: UIColor.brownColor(),
                name: "Braun"))
        
        // Die Hintergrundfarbe des Views
        self.view.backgroundColor =
          colorsInformation?.first?.color
    }
    
    func numberOfComponentsInPickerView(pickerView: UIPickerView) -> Int
    {
        // Anzahl der Spalten
        return 1
    }
    
    func pickerView(pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int
    {
        // Die Anzahl der Zeilen entspricht der
        // Anzahl der Objekte im Array.
       return self.colorsInformation!.count
    }

    func pickerView(pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String?
    {
        // Das ColorInformation-Objekt an der richtigen Stelle
        // aus dem Array holen
        if let colorInfo = colorsInformation?[row]
        {
            // Den Namen der Farbe zurückgeben
            return colorInfo.colorName
        }
        
        // Einen Leeren String zurück geben wenn
        // kein ColorInformation-Objekt zur 
        // verfügung steht
        return ""
    }
    
    func pickerView(pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int)
    {
        // Das ColorInformation-Objekt an der richtigen Stelle
        // aus dem Array holen
        if let colorInfo = colorsInformation?[row]
        {
            // Den View die Farbe als Hintergrundfarbe zuweisen
           self.view.backgroundColor = colorInfo.color
        }
    }
    
}

